#lang typed/racket/no-check

(: println (-> Number Void))
(define (println n)
  (define x (+ n 1))
  (displayln n))

;;   (
;; (lambda ([x : Number] [ y : String ])
;;   : String
;;   (+ x y))
;;   1 2)
(: if
  (All [T]
    (-> Boolean (-> T) (-> T) T)
  )
)
(define (if b then-branch else-branch)
  (cond
    [b (then-branch)]
    [else (else-branch)]
  )
)
(: factorial (-> Number Number))
(define (factorial n)
  (if (= n 0)
    (lambda () 1)
    (lambda () (* n (factorial (- n 1))))
  )
)

;; (factorial 1)
;;
;; (if #t (thunk 1) (lambda () "foo"))

(: f (-> Number))
; (define (f) (displayln "Called (f)") 0) ; <- equivalent
(define f
  (thunk
    (displayln "Called (f)")
    0
  )
)
(f)   ; Outputs: Called (f)
(f)   ; Outputs: Called (f)




(define (thunk-repeat n th)
  (cond [(<= n 0) (void)]
        [else
          (displayln ".")
          (th)
          (thunk-repeat (- n 1) th)]))

(define (promise-repeat n prom)
  (cond [(<= n 0) (void)]
        [else
          (displayln "*")
          (force prom)
          (promise-repeat (- n 1) prom) ]))


(thunk-repeat 3
  (thunk
    (displayln "Called thunk")
    (sleep 1)
    1
  )
)
(promise-repeat 3
  (delay
    (displayln "Called promise")
    (sleep 1)
    2
  )
)







